<html>
<head>
<title>Ogre::RTShader::TargetRenderState Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="namespaceOgre_1_1RTShader.html">RTShader</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html">TargetRenderState</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-static-methods">Static Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="#friends">Friends</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::RTShader::TargetRenderState Class Reference<div class="ingroups"><a class="el" href="group__RTShader.html">RTShader</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::RTShader::TargetRenderState" --><!-- doxytag: inherits="Ogre::RTShader::RenderState" -->
<p>This is the target render state.  
 <a href="classOgre_1_1RTShader_1_1TargetRenderState.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreShaderRenderState_8h_source.html">OgreShaderRenderState.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::RTShader::TargetRenderState:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1RTShader_1_1TargetRenderState__inherit__graph.gif" border="0" usemap="#Ogre_1_1RTShader_1_1TargetRenderState_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1RTShader_1_1TargetRenderState_inherit__map" id="Ogre_1_1RTShader_1_1TargetRenderState_inherit__map">
<area shape="rect" id="node2" href="classOgre_1_1RTShader_1_1RenderState.html" title="This is a container class for sub render state class." alt="" coords="24,83,221,112"/><area shape="rect" id="node4" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="45,5,200,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1RTShader_1_1TargetRenderState-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#af77db1b842b76ad71dd6a8fc1d2cfbfc">TargetRenderState</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Class default constructor.  <a href="#af77db1b842b76ad71dd6a8fc1d2cfbfc"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a72b162894e32d917fdde813f40f381e8">~TargetRenderState</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Class destructor.  <a href="#a72b162894e32d917fdde813f40f381e8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a48a0f2bf833e3dd562b68e16bdbcfef8">link</a> (const <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html">RenderState</a> &amp;other, <a class="el" href="classOgre_1_1Pass.html">Pass</a> *srcPass, <a class="el" href="classOgre_1_1Pass.html">Pass</a> *dstPass)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Link this target render state with the given render state.  <a href="#a48a0f2bf833e3dd562b68e16bdbcfef8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#ad201f02cccf5fe0db97ae3c103aba73b">updateGpuProgramsParams</a> (<a class="el" href="classOgre_1_1Renderable.html">Renderable</a> *rend, <a class="el" href="classOgre_1_1Pass.html">Pass</a> *pass, const <a class="el" href="classOgre_1_1AutoParamDataSource.html">AutoParamDataSource</a> *source, const <a class="el" href="group__General.html#gaab30ef14aae93306a6044cb38d835f0c">LightList</a> *pLightList)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Update the GPU programs constant parameters before a renderable is rendered.  <a href="#ad201f02cccf5fe0db97ae3c103aba73b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a0ca983d7872dd4af086d73f1685188f1">reset</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Reset this render state.  <a href="#a0ca983d7872dd4af086d73f1685188f1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#af66edaf33c654e03ef89f1eaec384a1f">addTemplateSubRenderState</a> (<a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *subRenderState)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Add a template sub render state to this render state.  <a href="#af66edaf33c654e03ef89f1eaec384a1f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#adf57c1505668d7cd9fc65c33231ee3ff">removeTemplateSubRenderState</a> (<a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *subRenderState)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove a template sub render state from this render state.  <a href="#adf57c1505668d7cd9fc65c33231ee3ff"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const <a class="el" href="group__RTShader.html#ga279d48a1cabb619e85aba3c931e71b33">SubRenderStateList</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a3156a7f08feecf6c0df8c2ec28d7e28a">getTemplateSubRenderStateList</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the list of the template sub render states composing this render state.  <a href="#a3156a7f08feecf6c0df8c2ec28d7e28a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a7d4bfe3ddbb10a94ae9e84d24fdcb5d8">setLightCount</a> (const int lightCount[3])</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the light count per light type.  <a href="#a7d4bfe3ddbb10a94ae9e84d24fdcb5d8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a1b891435cd80949d502ad448f8a203cf">getLightCount</a> (int lightCount[3]) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the light count per light type.  <a href="#a1b891435cd80949d502ad448f8a203cf"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#acd05f1eaf224a41f89b4c94823b96877">setLightCountAutoUpdate</a> (bool autoUpdate)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the light count auto update state.  <a href="#acd05f1eaf224a41f89b4c94823b96877"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a79777c200ca66ffe77b03f3462cbddbb">getLightCountAutoUpdate</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return true if this render state override the light count.  <a href="#a79777c200ca66ffe77b03f3462cbddbb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#af0cc11490a2a8d38b00befd3f68209bd">sortSubRenderStates</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sort the sub render states composing this render state.  <a href="#af0cc11490a2a8d38b00befd3f68209bd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a43689030b303d846f56d1325dbeb4e29">createCpuPrograms</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create CPU programs that represent this render state.  <a href="#a43689030b303d846f56d1325dbeb4e29"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1ProgramSet.html">ProgramSet</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a7b1fa1bf7f80b797042f3dc26043f733">createProgramSet</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create the program set of this render state.  <a href="#a7b1fa1bf7f80b797042f3dc26043f733"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#ac70b2331c9f7c36f98ef73e7892d8a25">destroyProgramSet</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1ProgramSet.html">ProgramSet</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a78bca39bab68931c862f04b3c6384d4b">getProgramSet</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the program set of this render state.  <a href="#a78bca39bab68931c862f04b3c6384d4b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a7a33d4ee212f7e8fb483cb33e36cf0fb">addSubRenderStateInstance</a> (<a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *subRenderState)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Add sub render state to this render state.  <a href="#a7a33d4ee212f7e8fb483cb33e36cf0fb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a5d7eb06c5a7db62569b4c8757282b9c8">removeSubRenderStateInstance</a> (<a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *subRenderState)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove sub render state from this render state.  <a href="#a5d7eb06c5a7db62569b4c8757282b9c8"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-static-methods"></a>
Static Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a9217c8ca6e166e12ae2d2478cf1d6e34">sSubRenderStateCompare</a> (const void *p0, const void *p1)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Comparison function of the sub render states.  <a href="#a9217c8ca6e166e12ae2d2478cf1d6e34"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a020129dfa474d4e35d37c0439f556663">mSubRenderStateSortValid</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1ProgramSet.html">ProgramSet</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a5ae4ed95d719aa2c2a15a2133c1e0f11">mProgramSet</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__RTShader.html#ga279d48a1cabb619e85aba3c931e71b33">SubRenderStateList</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a60de670ecb16e42e97f9bf8265270ea7">mSubRenderStateList</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a969c088c5e51a22c211c535375d139a8">mLightCount</a> [3]</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#aa36a91213f0c16fc4b68893911ad4f1e">mLightCountAutoUpdate</a></td></tr>
<tr><td colspan="2"><h2><a name="friends"></a>
Friends</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#ae46e120edae3a1f22dc68ebde7fbcfca">ProgramManager</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a0ebb9db4c085496981b7dbdd61f34fc9">FFPRenderStateBuilder</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This is the target render state. </p>
<p>This class will hold the actual generated CPU/GPU programs. It will be initially build from the FFP state of a given <a class="el" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a> by the FFP builder and then will be linked with the custom pass render state and the global scheme render state. See <a class="el" href="classOgre_1_1RTShader_1_1ShaderGenerator_1_1SGPass.html#a72c2fadabc311df85cb98acca620700c" title="Build the render state.">ShaderGenerator::SGPass::buildTargetRenderState()</a>. </p>

<p>Definition at line <a class="el" href="OgreShaderRenderState_8h_source.html#l00136">136</a> of file <a class="el" href="OgreShaderRenderState_8h_source.html">OgreShaderRenderState.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="af77db1b842b76ad71dd6a8fc1d2cfbfc"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::TargetRenderState" ref="af77db1b842b76ad71dd6a8fc1d2cfbfc" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#af77db1b842b76ad71dd6a8fc1d2cfbfc">Ogre::RTShader::TargetRenderState::TargetRenderState</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Class default constructor. </p>

</div>
</div>
<a class="anchor" id="a72b162894e32d917fdde813f40f381e8"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::~TargetRenderState" ref="a72b162894e32d917fdde813f40f381e8" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a72b162894e32d917fdde813f40f381e8">Ogre::RTShader::TargetRenderState::~TargetRenderState</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Class destructor. </p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a7a33d4ee212f7e8fb483cb33e36cf0fb"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::addSubRenderStateInstance" ref="a7a33d4ee212f7e8fb483cb33e36cf0fb" args="(SubRenderState *subRenderState)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a7a33d4ee212f7e8fb483cb33e36cf0fb">Ogre::RTShader::TargetRenderState::addSubRenderStateInstance</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *&#160;</td>
          <td class="paramname"><em>subRenderState</em></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add sub render state to this render state. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">subRenderState</td><td>The sub render state to add. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="af66edaf33c654e03ef89f1eaec384a1f"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::addTemplateSubRenderState" ref="af66edaf33c654e03ef89f1eaec384a1f" args="(SubRenderState *subRenderState)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#af66edaf33c654e03ef89f1eaec384a1f">Ogre::RTShader::RenderState::addTemplateSubRenderState</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *&#160;</td>
          <td class="paramname"><em>subRenderState</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add a template sub render state to this render state. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">subRenderState</td><td>The sub render state template to add. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a43689030b303d846f56d1325dbeb4e29"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::createCpuPrograms" ref="a43689030b303d846f56d1325dbeb4e29" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a43689030b303d846f56d1325dbeb4e29">Ogre::RTShader::TargetRenderState::createCpuPrograms</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create CPU programs that represent this render state. </p>

</div>
</div>
<a class="anchor" id="a7b1fa1bf7f80b797042f3dc26043f733"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::createProgramSet" ref="a7b1fa1bf7f80b797042f3dc26043f733" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1ProgramSet.html">ProgramSet</a>* <a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a7b1fa1bf7f80b797042f3dc26043f733">Ogre::RTShader::TargetRenderState::createProgramSet</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create the program set of this render state. </p>

</div>
</div>
<a class="anchor" id="ac70b2331c9f7c36f98ef73e7892d8a25"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::destroyProgramSet" ref="ac70b2331c9f7c36f98ef73e7892d8a25" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#ac70b2331c9f7c36f98ef73e7892d8a25">Ogre::RTShader::TargetRenderState::destroyProgramSet</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a1b891435cd80949d502ad448f8a203cf"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::getLightCount" ref="a1b891435cd80949d502ad448f8a203cf" args="(int lightCount[3]) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a1b891435cd80949d502ad448f8a203cf">Ogre::RTShader::RenderState::getLightCount</a> </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>lightCount</em>[3]</td><td>)</td>
          <td> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the light count per light type. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">lightCount</td><td>The light count per type. lightCount[0] defines the point light count. lightCount[1] defines the directional light count. lightCount[2] defines the spot light count. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a79777c200ca66ffe77b03f3462cbddbb"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::getLightCountAutoUpdate" ref="a79777c200ca66ffe77b03f3462cbddbb" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a79777c200ca66ffe77b03f3462cbddbb">Ogre::RTShader::RenderState::getLightCountAutoUpdate</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return true if this render state override the light count. </p>
<p>If light count is not overridden it will be updated from the shader generator based on current scene lights. </p>

<p>Definition at line <a class="el" href="OgreShaderRenderState_8h_source.html#l00110">110</a> of file <a class="el" href="OgreShaderRenderState_8h_source.html">OgreShaderRenderState.h</a>.</p>

</div>
</div>
<a class="anchor" id="a78bca39bab68931c862f04b3c6384d4b"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::getProgramSet" ref="a78bca39bab68931c862f04b3c6384d4b" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1ProgramSet.html">ProgramSet</a>* <a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a78bca39bab68931c862f04b3c6384d4b">Ogre::RTShader::TargetRenderState::getProgramSet</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the program set of this render state. </p>

<p>Definition at line <a class="el" href="OgreShaderRenderState_8h_source.html#l00187">187</a> of file <a class="el" href="OgreShaderRenderState_8h_source.html">OgreShaderRenderState.h</a>.</p>

<p>References <a class="el" href="OgreShaderRenderState_8h_source.html#l00203">mProgramSet</a>.</p>

</div>
</div>
<a class="anchor" id="a3156a7f08feecf6c0df8c2ec28d7e28a"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::getTemplateSubRenderStateList" ref="a3156a7f08feecf6c0df8c2ec28d7e28a" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="group__RTShader.html#ga279d48a1cabb619e85aba3c931e71b33">SubRenderStateList</a>&amp; <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a3156a7f08feecf6c0df8c2ec28d7e28a">Ogre::RTShader::RenderState::getTemplateSubRenderStateList</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the list of the template sub render states composing this render state. </p>

<p>Definition at line <a class="el" href="OgreShaderRenderState_8h_source.html#l00076">76</a> of file <a class="el" href="OgreShaderRenderState_8h_source.html">OgreShaderRenderState.h</a>.</p>

</div>
</div>
<a class="anchor" id="a48a0f2bf833e3dd562b68e16bdbcfef8"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::link" ref="a48a0f2bf833e3dd562b68e16bdbcfef8" args="(const RenderState &amp;other, Pass *srcPass, Pass *dstPass)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a48a0f2bf833e3dd562b68e16bdbcfef8">Ogre::RTShader::TargetRenderState::link</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html">RenderState</a> &amp;&#160;</td>
          <td class="paramname"><em>other</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Pass.html">Pass</a> *&#160;</td>
          <td class="paramname"><em>srcPass</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Pass.html">Pass</a> *&#160;</td>
          <td class="paramname"><em>dstPass</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Link this target render state with the given render state. </p>
<p>Only sub render states with execution order that don't exist in this render state will be added. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">other</td><td>The other render state to append to this state. </td></tr>
    <tr><td class="paramname">srcPass</td><td>The source pass that this render state is constructed from. </td></tr>
    <tr><td class="paramname">dstPass</td><td>The destination pass that constructed from this render state. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a5d7eb06c5a7db62569b4c8757282b9c8"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::removeSubRenderStateInstance" ref="a5d7eb06c5a7db62569b4c8757282b9c8" args="(SubRenderState *subRenderState)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a5d7eb06c5a7db62569b4c8757282b9c8">Ogre::RTShader::TargetRenderState::removeSubRenderStateInstance</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *&#160;</td>
          <td class="paramname"><em>subRenderState</em></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Remove sub render state from this render state. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">subRenderState</td><td>The sub render state to remove. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="adf57c1505668d7cd9fc65c33231ee3ff"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::removeTemplateSubRenderState" ref="adf57c1505668d7cd9fc65c33231ee3ff" args="(SubRenderState *subRenderState)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#adf57c1505668d7cd9fc65c33231ee3ff">Ogre::RTShader::RenderState::removeTemplateSubRenderState</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *&#160;</td>
          <td class="paramname"><em>subRenderState</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Remove a template sub render state from this render state. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">subRenderState</td><td>The sub render state to remove. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a0ca983d7872dd4af086d73f1685188f1"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::reset" ref="a0ca983d7872dd4af086d73f1685188f1" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a0ca983d7872dd4af086d73f1685188f1">Ogre::RTShader::RenderState::reset</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Reset this render state. </p>

</div>
</div>
<a class="anchor" id="a7d4bfe3ddbb10a94ae9e84d24fdcb5d8"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::setLightCount" ref="a7d4bfe3ddbb10a94ae9e84d24fdcb5d8" args="(const int lightCount[3])" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a7d4bfe3ddbb10a94ae9e84d24fdcb5d8">Ogre::RTShader::RenderState::setLightCount</a> </td>
          <td>(</td>
          <td class="paramtype">const int&#160;</td>
          <td class="paramname"><em>lightCount</em>[3]</td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the light count per light type. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">lightCount</td><td>The light count per type. lightCount[0] defines the point light count. lightCount[1] defines the directional light count. lightCount[2] defines the spot light count. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="acd05f1eaf224a41f89b4c94823b96877"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::setLightCountAutoUpdate" ref="acd05f1eaf224a41f89b4c94823b96877" args="(bool autoUpdate)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#acd05f1eaf224a41f89b4c94823b96877">Ogre::RTShader::RenderState::setLightCountAutoUpdate</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>autoUpdate</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the light count auto update state. </p>
<p>If the value is false the light count will remain static for the values that were set by the user. If the value is true the light count will be updated from the owner shader generator scheme based on current scene lights. The default is true. </p>

<p>Definition at line <a class="el" href="OgreShaderRenderState_8h_source.html#l00104">104</a> of file <a class="el" href="OgreShaderRenderState_8h_source.html">OgreShaderRenderState.h</a>.</p>

</div>
</div>
<a class="anchor" id="af0cc11490a2a8d38b00befd3f68209bd"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::sortSubRenderStates" ref="af0cc11490a2a8d38b00befd3f68209bd" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#af0cc11490a2a8d38b00befd3f68209bd">Ogre::RTShader::TargetRenderState::sortSubRenderStates</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sort the sub render states composing this render state. </p>

</div>
</div>
<a class="anchor" id="a9217c8ca6e166e12ae2d2478cf1d6e34"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::sSubRenderStateCompare" ref="a9217c8ca6e166e12ae2d2478cf1d6e34" args="(const void *p0, const void *p1)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static int <a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a9217c8ca6e166e12ae2d2478cf1d6e34">Ogre::RTShader::TargetRenderState::sSubRenderStateCompare</a> </td>
          <td>(</td>
          <td class="paramtype">const void *&#160;</td>
          <td class="paramname"><em>p0</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const void *&#160;</td>
          <td class="paramname"><em>p1</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static, protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Comparison function of the sub render states. </p>

</div>
</div>
<a class="anchor" id="ad201f02cccf5fe0db97ae3c103aba73b"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::updateGpuProgramsParams" ref="ad201f02cccf5fe0db97ae3c103aba73b" args="(Renderable *rend, Pass *pass, const AutoParamDataSource *source, const LightList *pLightList)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#ad201f02cccf5fe0db97ae3c103aba73b">Ogre::RTShader::TargetRenderState::updateGpuProgramsParams</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Renderable.html">Renderable</a> *&#160;</td>
          <td class="paramname"><em>rend</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Pass.html">Pass</a> *&#160;</td>
          <td class="paramname"><em>pass</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1AutoParamDataSource.html">AutoParamDataSource</a> *&#160;</td>
          <td class="paramname"><em>source</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="group__General.html#gaab30ef14aae93306a6044cb38d835f0c">LightList</a> *&#160;</td>
          <td class="paramname"><em>pLightList</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Update the GPU programs constant parameters before a renderable is rendered. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">rend</td><td>The renderable object that is going to be rendered. </td></tr>
    <tr><td class="paramname">pass</td><td>The pass that is used to do the rendering operation. </td></tr>
    <tr><td class="paramname">source</td><td>The auto parameter auto source instance. </td></tr>
    <tr><td class="paramname">pLightList</td><td>The light list used for the current rendering operation. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/><h2>Friends And Related Function Documentation</h2>
<a class="anchor" id="a0ebb9db4c085496981b7dbdd61f34fc9"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::FFPRenderStateBuilder" ref="a0ebb9db4c085496981b7dbdd61f34fc9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">friend class <a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a0ebb9db4c085496981b7dbdd61f34fc9">FFPRenderStateBuilder</a><code> [friend]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Reimplemented from <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a0ebb9db4c085496981b7dbdd61f34fc9">Ogre::RTShader::RenderState</a>.</p>

<p>Definition at line <a class="el" href="OgreShaderRenderState_8h_source.html#l00208">208</a> of file <a class="el" href="OgreShaderRenderState_8h_source.html">OgreShaderRenderState.h</a>.</p>

</div>
</div>
<a class="anchor" id="ae46e120edae3a1f22dc68ebde7fbcfca"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::ProgramManager" ref="ae46e120edae3a1f22dc68ebde7fbcfca" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">friend class <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html">ProgramManager</a><code> [friend]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Reimplemented from <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#ae46e120edae3a1f22dc68ebde7fbcfca">Ogre::RTShader::RenderState</a>.</p>

<p>Definition at line <a class="el" href="OgreShaderRenderState_8h_source.html#l00207">207</a> of file <a class="el" href="OgreShaderRenderState_8h_source.html">OgreShaderRenderState.h</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a969c088c5e51a22c211c535375d139a8"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::mLightCount" ref="a969c088c5e51a22c211c535375d139a8" args="[3]" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a969c088c5e51a22c211c535375d139a8">Ogre::RTShader::RenderState::mLightCount</a>[3]<code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderRenderState_8h_source.html#l00118">118</a> of file <a class="el" href="OgreShaderRenderState_8h_source.html">OgreShaderRenderState.h</a>.</p>

</div>
</div>
<a class="anchor" id="aa36a91213f0c16fc4b68893911ad4f1e"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::mLightCountAutoUpdate" ref="aa36a91213f0c16fc4b68893911ad4f1e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#aa36a91213f0c16fc4b68893911ad4f1e">Ogre::RTShader::RenderState::mLightCountAutoUpdate</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderRenderState_8h_source.html#l00119">119</a> of file <a class="el" href="OgreShaderRenderState_8h_source.html">OgreShaderRenderState.h</a>.</p>

</div>
</div>
<a class="anchor" id="a5ae4ed95d719aa2c2a15a2133c1e0f11"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::mProgramSet" ref="a5ae4ed95d719aa2c2a15a2133c1e0f11" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1ProgramSet.html">ProgramSet</a>* <a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a5ae4ed95d719aa2c2a15a2133c1e0f11">Ogre::RTShader::TargetRenderState::mProgramSet</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderRenderState_8h_source.html#l00203">203</a> of file <a class="el" href="OgreShaderRenderState_8h_source.html">OgreShaderRenderState.h</a>.</p>

<p>Referenced by <a class="el" href="OgreShaderRenderState_8h_source.html#l00187">getProgramSet()</a>.</p>

</div>
</div>
<a class="anchor" id="a60de670ecb16e42e97f9bf8265270ea7"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::mSubRenderStateList" ref="a60de670ecb16e42e97f9bf8265270ea7" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__RTShader.html#ga279d48a1cabb619e85aba3c931e71b33">SubRenderStateList</a> <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a60de670ecb16e42e97f9bf8265270ea7">Ogre::RTShader::RenderState::mSubRenderStateList</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderRenderState_8h_source.html#l00117">117</a> of file <a class="el" href="OgreShaderRenderState_8h_source.html">OgreShaderRenderState.h</a>.</p>

</div>
</div>
<a class="anchor" id="a020129dfa474d4e35d37c0439f556663"></a><!-- doxytag: member="Ogre::RTShader::TargetRenderState::mSubRenderStateSortValid" ref="a020129dfa474d4e35d37c0439f556663" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a020129dfa474d4e35d37c0439f556663">Ogre::RTShader::TargetRenderState::mSubRenderStateSortValid</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderRenderState_8h_source.html#l00202">202</a> of file <a class="el" href="OgreShaderRenderState_8h_source.html">OgreShaderRenderState.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreShaderRenderState_8h_source.html">OgreShaderRenderState.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:33
</p>
</body>
</html>
